## Readme

Our implementation is built upon the open source code from "Differential privacy has disparate impact on model accuracy"[2] ([repo]https://github.com/ebagdasa/differential-privacy-vs-fairness). 

The paper discusses how Differential Privacy (specifically DPSGD from [1]) impacts model performance for underrepresented groups. 

### Usage

Configure environment by running: `pip install -r requirements.txt`

We use Python3.7 and GPU Nvidia Tesla P100.

File dpsgd.py (the same as playing.py in [2]) allows run the code of [1]. It uses `utils/params_mnist.yaml` to set parameters from the paper and builds a graph on Tensorboard.
	$ python dpsgd.py --name mnist --params utils/params_mnist.yaml

File dpsgdf.py allows run the code of our work. It uses `utils/params_mnist.yaml` to set parameters from the paper and builds a graph on Tensorboard.
	$ python dpsgdf.py --name mnist --params utils/params_mnist.yaml


Datasets:
MNIST (part of PyTorch)

We use `compute_dp_sgd_privacy.py` copied from public [repo](https://github.com/tensorflow/privacy). We made small modification on `compute_dp_sgd_privacy.py` for composition of moments accountant.

DP-FedAvg implementation is taken from public [repo](https://github.com/ebagdasa/backdoor_federated_learning)  

Implementation of DPSGD is based on TF Privacy [repo](https://github.com/tensorflow/privacy) and papers:

[1] Martin Abadi, Andy Chu, Ian J. Goodfellow, H. Brendan McMahan, Ilya Mironov,Kunal Talwar, and Li Zhang. Deep learning with differential privacy. InProceedingsof CCS, Vienna, Austria, October 24-28, 2016, pages 308–318, 2016.

[2] Eugene Bagdasaryan, Omid Poursaeed, and Vitaly Shmatikov.  Differential privacy has disparate impact on model accuracy. InNeurIPS 2019, 8-14 December 2019,Vancouver, BC, Canada, pages 15453–15462, 2019.